---
layout: default
title: What's New
permalink: /change-logs/
---

## What's New

### v0.27
- Kernel SU support.
- More materialized app UI.
- Build with latest gradle and dependencies.
- Miscellaneous changes.

### v0.26
- Exp: Included '/system/preload' to support list.
- Exporting profiles now allows using custom names.
- Searching apps now consider for both app and package names.
- Replaced depreciated onActivityResult with ActivityResultLauncher
- Added Japanese and Chinese (Simplified & Traditional - HK) translations.
- Updated other translations.
- Updated build tools and dependencies.
- Miscellaneous changes.

### v0.25
- Improved app updates.
- Added French (Belgian), Portuguese (Brazilian) and Chinese (Traditional) translations.
- Updated other translations.
- Updated build tools and dependencies.
- Miscellaneous changes.

### v0.24
- Added Vietnamese and Chinese (Simplified) translations.
- Updated French translations.
- Updated build tools and dependencies.
- Miscellaneous changes.

### v0.23
- Added French translations (incomplete).
- Updated Italian & Polish translations.
- Updated Credits.
- Miscellaneous changes.

### v0.22
- Improved and enhanced main UI.
- Added option to Swipe change pages.
- Added new credits page.  
- Updated translations message.
- Main UI now includes package names.
- Added searching in Inactive apps page.
- De-Bloater now targets Android 12 (S, SDK 31).
- Miscellaneous changes.

### v0.21
- Fixed crashing Tomatot Debloater page.
- Fixed crashing app when root access is unavailable.
- Updated gradle plugin.
- Miscellaneous changes.

### v0.20
- De-Bloater now handles updated system apps.
- Improved backup/restore profiles.
- Miscellaneous changes.

### v0.19
- Largely improved app UI response.
- Replaced deprecated AsyncTask with a custom one.
- Added a welcome screen on the first app launch.
- Cleaned a lot of unnecessary code and largely improved coding quality.
- Enhanced Tomatot debloater.
- A lot more improvements under-the-hood.

### v0.18
- Improved case sensitivity in searching.
- Updated gradle build tools.
- Miscellaneous changes.

### v0.17
- Allow debloating more apps (e.g. from /system_ext (need more testing) and /product/priv-app folders).
- Added Polish & German translations and updated others.
- Updated gradle plugin.
- Internal improvements.
- Miscellaneous changes.

### v0.16
- Updates for Android 11.
- App will now targets latest SDK.
- Implement own file picker for restore activities.
- Improved searching.
- Miscellaneous changes.

### v0.15
- Added a top TabLayout to easily switch app types.
- Fixed likely crashes on Android 11.
- Miscellaneous changes.

### v0.14
- Added Spanish and Italian translations.
- Updated some options in about page.
- Miscellaneous changes.

### v0.13
- Improved Universal Android and Tomatot debloater.
- Updated Turkish and Russian translation.
- Updated storage handling for Android 10 and above.
- Updated build tools and dependencies.
- Miscellaneous changes.

### v0.12
- Adapted Universal Android Debloater by @W1nst0n.
- Re-organized and largely improved coding.
- Slightly improved app UI.
- Added a start-up warning message.
- Temporarily fixed storage relates issues on Android 11.
- Updated build tools and dependencies.
- Miscellaneous changes.

### v0.11
- Added Turkish translations.
- Miscellaneous changes.

### v0.10
- Workaround to disable auto-update check on installation from F-Droid.
- Added detailed change-logs and licence views.
- Miscellaneous changes.

### v0.9
- Introduced a signature check to avoid conflicts with F-Droid.

### v0.8
- Updated Russian & Ukrainian translations.
- Updates for F-Droid submission.
- Miscellaneous changes.

### v0.7
- Use Magisk BusyBox binaries as much as possible.
- Updated app icon.
- Miscellaneous changes.

### v0.6
- Added backup and restore options.
- Use material style elements as much as possible.
- Miscellaneous changes.

### v0.5
- Added custom script page.
- Switched to blue accent color.
- Added Ukrainian translation.
- Updated Russian translation.
- Miscellaneous changes.

### v0.4
- Fixed search results occasionally duplicating.
- Colorize (with accent) titles on recycle view.
- Added a donate option.
- Added Russian translation.
- Added option to reverse app list.
- Miscellaneous changes.

### v0.3
- Added option to show apps from specific folders.
- Improved inactive app handling.
- Show app logo on startup.
- Improved app searching.
- Miscellaneous changes.

### v0.2
- Added options to sort active packages by name or package id.
- Improved restoring de-bloated apps.
- Implemented separate pop-up menu for individual pages.
- Slightly improved app UI.
- Miscellaneous changes.

### v0.1
- Initial release.